begin
   with VRMLFile do begin
      Clear;
      // generate Viewpoints
      with NewViewPoint do begin
        Position.SetXYZ(0,0,150);
        Orientation.SetXYZA(0,0,0,0);
        Description:='Z';
        Jump:= false;
      end;
      with NewViewPoint do begin
        Position.SetXYZ(-150,0,50);
        Orientation.SetXYZA(0,1,0,-pi/2);
        Description:='X';
        Jump:= false;
      end;
      with NewTransform do begin
        Rotation.SetXYZA(0, 0, 1, -pi/2);
        with NewViewPoint do begin
          Position.SetXYZ(-150,0,50);
          Orientation.SetXYZA(0,1,0,-pi/2);
          Description:='Y';
          Jump:= false;
        end;
      end;
      with NewViewPoint do begin
        Position.SetXYZ(0,0,-20);
        Orientation.SetXYZA(0,1,0,pi);
        Description:='Z1';
        Jump:= false;
      end;
      // set white background color
      with NewBackground do begin
        SkyColor.Add(1,1,1);
      end;
      with NewGroup do begin
        // generate first coordinate axis
        with NewGroup do begin
          DEF:= 'axis'; // set axis name
          with NewShape do begin
            Appearance.DEF:= 'blackline'; // set appearance name
            //set lines color
            Appearance.Material.DiffuseColor.SetRGB(0,0,0);
            Appearance.Material.EmissiveColor.SetRGB(0,0,0);
            //draw line
            Geometry.NodeType:= gtIndexedLineSet;
            with Geometry.Coord.Point do begin
              Add(0,-10,0);
              Add(0,10,0);
            end;
            with Geometry.CoordIndex do begin
              Add(0);
              Add(1);
            end;
          end;
          with NewTransform do begin
            Translation.SetXYZ(0,9,0);
            with NewShape do begin
              Appearance.Text:= 'USE blackline';// use defined appearance
              Geometry.NodeType:= gtCone;
              Geometry.Radius:= 0.5;
            end;
          end;
        end;
        // generate second coordinate axis
        with NewTransform do begin
          Rotation.SetXYZA(1,0,0,pi/2);
          with NewShape do begin
            Text:= 'USE axis';// use defined figure
          end;
        end;
        // generate third coordinate axis
        with NewTransform do begin
          Rotation.SetXYZA(0,0,1,-pi/2);
          with NewShape do begin
            Text:= 'USE axis';// use defined figure
          end;
        end;
      end;
      // generate sphere in zero
      with NewAnchor do begin
        URL.Add('http://www.atomintersoft.com/');
        Parameter.Add('target=_blanck');
        Description:= 'AtomInterSoft site';
        with NewShape do begin
          Appearance.Texture.URL:= 'ais_logo2.gif';// use texture
          Geometry.NodeType:= gtSphere;
          Geometry.Radius:= 1;
        end;
      end;
      //generate poliline
      with NewShape do begin
        // use red color
        Appearance.Material.DiffuseColor.SetRGB(1,0,0);
        Appearance.Material.EmissiveColor.SetRGB(1,0,0);
        Geometry.NodeType:= gtIndexedLineSet;
        for i:= 0 to 100 do begin
          // add point
          Geometry.Coord.Point.Add( 5*sin(i*0.1), 5*cos(i*0.5), i);
          // add line point index
          Geometry.CoordIndex.Add(i);
        end;
      end;
   end;
end
