begin
   with VRMLFile do begin
      Clear;
      // generate Viewpoints
      with NewViewPoint do begin
        Position.SetXYZ(0,0,70);
        Orientation.SetXYZA(0,0,0,0);
        Description:='Z';
        Jump:= false;
      end;
      // set white background color
      with NewBackground do begin
        SkyColor.Add(0.2,0.2,1);
        SkyColor.Add(0.8,0.8,1);
        SkyAngle.Add(pi/2);
        SkyAngle.Add(2.14);
        GroundColor.Add(0.99,0.99,1);
        GroundColor.Add(0.95,0.95,1);
      end;
      // generate New Year's tree
      with NewGroup do begin
          DEF:= 'tree';
          with NewShape do begin
            Appearance.DEF:= 'green'; // set appearance name
            //set lines color
            Appearance.Material.DiffuseColor.SetRGB(0,0.5,0);
            Appearance.Material.EmissiveColor.SetRGB(0,0.7,0);
            //draw first cone
            Geometry.NodeType:= gtCone;
            Geometry.Radius:= 3;
            Geometry.Height:= 6;
          end;
          with NewTransform do begin
            Translation.SetXYZ(0,3,0);
            with NewShape do begin
              Appearance.Text:= 'USE green'; // set appearance name
              //draw first cone
              Geometry.NodeType:= gtCone;
              Geometry.Radius:= 2;
              Geometry.Height:= 4;
            end;
          end;
          with NewTransform do begin
            Translation.SetXYZ(0,5,0);
            with NewShape do begin
              Appearance.Text:= 'USE green'; // set appearance name
              //draw first cone
              Geometry.NodeType:= gtCone;
              Geometry.Radius:= 1.5;
              Geometry.Height:= 3;
            end;
          end;
          with NewTransform do begin
            Translation.SetXYZ(0,-3,0);
            with NewShape do begin
              Appearance.Material.DiffuseColor.SetRGB(0.3,0.3,0);
              Appearance.Material.EmissiveColor.SetRGB(0.4,0.4,0);
              //draw first cone
              Geometry.NodeType:= gtCylinder;
              Geometry.Radius:= 0.5;
              Geometry.Height:= 2;
            end;
          end;
      end;
      // generate snow man
      with NewGroup do begin
        DEF:= 'snowman';
        with NewTransform  do begin

          Translation.SetXYZ(10,-2,0);
          with NewShape do begin
            Appearance.DEF:= 'blue'; // set appearance name
            //set lines color
            Appearance.Material.DiffuseColor.SetRGB(0.3,0.3,0.5);
            Appearance.Material.EmissiveColor.SetRGB(0.3,0.3,0.7);
            //draw first cone
            Geometry.NodeType:= gtSphere;
            Geometry.Radius:= 2;
          end;
        end;

        with NewTransform do begin
          Translation.SetXYZ(10,1,0);
          with NewShape do begin
            Appearance.Text:= 'USE blue'; // set appearance name
            //draw first cone
            Geometry.NodeType:= gtSphere;
            Geometry.Radius:= 1.5;
          end;
        end;
        with NewTransform do begin
          Translation.SetXYZ(10,3,0);
          with NewShape do begin
            Appearance.Text:= 'USE blue'; // set appearance name
            //draw first cone
            Geometry.NodeType:= gtSphere;
            Geometry.Radius:= 1;
          end;
        end;
      end;
      //generate forest
      randomize;
      for i:=0 to 40 do begin
        with NewTransform do begin
            Translation.SetXYZ(random(50)-25,0,random(50)-25);
            Scale.SetXYZ(0.7+random(50)/100,0.5+random(120)/100,0.7+random(50)/100);
            with NewGroup do begin
              Text:= 'USE tree'; // set appearance name
            end;
        end;
      end;
      for i:=0 to 10 do begin
        with NewTransform do begin
            Translation.SetXYZ(random(50)-25,0,random(50)-25);
            Scale.SetXYZ(0.8+random(20)/100,0.5+random(50)/100,0.8+random(20)/100);
            with NewGroup do begin
              Text:= 'USE snowman'; // set appearance name
            end;
        end;
      end;
      with NewShape do begin // generate starts on the sky
        Geometry.NodeType:= gtPointSet;
        for i:= 0 to 1000 do begin
          d:= random*pi*2;
          d1:= random*pi/2;
          Geometry.Coord.Point.Add(100*sin(d)*sin(d1),100*cos(d1),100*cos(d)*sin(d1));
          Geometry.Color.Color.Add(0.7+random(30)/100,0.7+random(30)/100,0.7+random(30)/100);
        end
      end;
      with NewTransform do begin
        Translation.SetXYZ(-200,0,-250);
        with NewShape do begin
          Appearance.Material.DiffuseColor.SetRGB(0.3,0.3,0.9);
          Appearance.Material.EmissiveColor.SetRGB(0.3,0.3,0.9);
          with NewText do begin
            MString.Add('Happy New Year!');
            FontStyle.Style:= fsItalic;
            FontStyle.Size:= 64;
          end;
        end;
      end;
    end;
end
