begin
   with VRMLFile do begin
      Clear;
      // generate Viewpoints
      with NewTransform do begin
        Rotation.SetXYZA(1, 1, 1, -pi/6);
        with NewViewPoint do begin
          Position.SetXYZ(0,10,80);
          Orientation.SetXYZA(0,0,0,0);
          Description:='Z';
          Jump:= false;
        end;
      end;
      with NewViewPoint do begin
        Position.SetXYZ(-80,0,0);
        Orientation.SetXYZA(0,1,0,-pi/2);
        Description:='X';
        Jump:= false;
      end;
      with NewTransform do begin
        Rotation.SetXYZA(0, 0, 1, -pi/2);
        with NewViewPoint do begin
          Position.SetXYZ(-80,0,0);
          Orientation.SetXYZA(0,1,0,-pi/2);
          Description:='Y';
          Jump:= false;
        end;
      end;
      with NewViewPoint do begin
        Position.SetXYZ(0,0,-50);
        Orientation.SetXYZA(0,1,0,pi);
        Description:='Z1';
        Jump:= false;
      end;
      // set white background color
      with NewBackground do begin
        SkyColor.Add(1,1,1);
      end;
      with NewGroup do begin
        // generate first coordinate axis
        with NewGroup do begin
          DEF:= 'axis'; // set axis name
          with NewShape do begin
            Appearance.DEF:= 'blackline'; // set appearance name
            //set lines color
            Appearance.Material.DiffuseColor.SetRGB(0,0,0);
            Appearance.Material.EmissiveColor.SetRGB(0,0,0);
            //draw line
            Geometry.NodeType:= gtIndexedLineSet;
            with Geometry.Coord.Point do begin
              Add(0,-20,0);
              Add(0,20,0);
            end;
            with Geometry.CoordIndex do begin
              Add(0);
              Add(1);
            end;
          end;
          with NewTransform do begin
            Translation.SetXYZ(0,20,0);
            with NewShape do begin
              Appearance.Text:= 'USE blackline';// use defined appearance
              Geometry.NodeType:= gtCone;
              Geometry.Radius:= 0.5;
            end;
          end;
        end;
        // generate second coordinate axis
        with NewTransform do begin
          Rotation.SetXYZA(1,0,0,pi/2);
          with NewShape do begin
            Text:= 'USE axis';// use defined figure
          end;
        end;
        // generate third coordinate axis
        with NewTransform do begin
          Rotation.SetXYZA(0,0,1,-pi/2);
          with NewShape do begin
            Text:= 'USE axis';// use defined figure
          end;
        end;
      end;
      // generate sphere in zero
      with NewShape do begin
        Appearance.Texture.URL:= 'ais_logo2.gif';// use texture
        Geometry.NodeType:= gtSphere;
        Geometry.Radius:= 1;
      end;
      //generate poliline
      with NewShape do begin
        // use red color
        Geometry.NodeType:= gtIndexedFaceSet;
        Geometry.ColorPerVertex:= true;
        Geometry.Solid:= false;
        for i:= -20 to 20 do begin
          for j:= -20 to 20 do begin
            d:=sqrt(i*i+j*j);
            if d=0 then begin
              d1:=1; d:=1;
            end
            else d1:=d;
            // add point
            Geometry.Coord.Point.Add( i, 25*sin(d*0.5)/d1, j);
            // add color of point
            Geometry.Color.Color.Add( (i+j+40)/100, (j+20)/45, (20-i)/45);
          end;
        end;
        // add triangle
        for i:= 0 to 39 do begin
          for j:= 0 to 39 do begin
            Geometry.CoordIndex.Add(j+i*41);
            Geometry.CoordIndex.Add(j+i*41+1);
            Geometry.CoordIndex.Add(j+i*41+41);
            Geometry.CoordIndex.Add(-1);
          end;
        end;
      end;
   end;
end
