unit f_Main;
{##########################################################################
#
#   AIS VRML Class Library
#   version 1.0
#
#   Copyright (c) 2000 AtomInterSoft
#   WWW:    http://www.atomintersoft.com
#   E-main: contact@bloodays.com
#
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, AiSVrmlA;

type
  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Memo1: TMemo;
    TreeView1: TTreeView;
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    base: string;
    VRMLFile: TAiSVRMLFile;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
uses ShellAPI;

{$R *.DFM}

function Exec(const ProgramName, Params: string; ShowCode: Integer; Wait : boolean): string;
var ExecInfo: TShellExecuteInfo;
    ExitCode : DWORD;
begin
  FillChar(ExecInfo, SizeOf(ExecInfo), 0);
  ExecInfo.cbSize := SizeOf(TShellExecuteInfo);
  with ExecInfo do begin
    fMask := SEE_MASK_NOCLOSEPROCESS;
    Wnd := Application.Handle;
    GetMem(lpFile, length(ProgramName)+1);
    GetMem(lpParameters, length(Params)+1);
    StrPCopy(lpFile, ProgramName);
    StrPCopy(lpParameters, Params);
    nShow := ShowCode;
  end;
  if ShellExecuteEx(@ExecInfo) then begin
    if Wait then
      repeat
        Application.ProcessMessages;
        GetExitCodeProcess(ExecInfo.hProcess, ExitCode);
      until (ExitCode <> STILL_ACTIVE) or Application.Terminated;
    Result := '';
  end
  else Result := SysErrorMessage(GetLastError);
end;


procedure TForm2.TreeView1Change(Sender: TObject; Node: TTreeNode);
var j,i,idx: integer;
  d, d1: double;
  idset: set of byte;
begin
  idset:= [2, 12, 22, 32, 42];
  cCR:='';
  case Node.ImageIndex of
    //show examples descriptions
    00: Memo1.Lines.LoadFromFile(base+'examlpe1.txt');
    10: Memo1.Lines.LoadFromFile(base+'examlpe2.txt');
    20: Memo1.Lines.LoadFromFile(base+'examlpe3.txt');
    30: Memo1.Lines.LoadFromFile(base+'examlpe4.txt');
    40: Memo1.Lines.LoadFromFile(base+'examlpe5.txt');
    // show delphi sources for VRML generation
    01: Memo1.Lines.LoadFromFile(base+'examlpe1.inc');
    11: Memo1.Lines.LoadFromFile(base+'examlpe2.inc');
    21: Memo1.Lines.LoadFromFile(base+'examlpe3.inc');
    31: Memo1.Lines.LoadFromFile(base+'examlpe4.inc');
    41: Memo1.Lines.LoadFromFile(base+'examlpe5.inc');
    // generate VRML ( see included files *.inc )
    02: {$i examlpe1.inc};
    12: {$i examlpe2.inc};
    22: {$i examlpe3.inc};
    32: {$i examlpe4.inc};
    42: {$i examlpe5.inc};
    // show existing VRML files
    101: Memo1.Lines.LoadFromFile(base+'vrml101.wrl');
    102: Memo1.Lines.LoadFromFile(base+'vrml102.wrl');
    103: Memo1.Lines.LoadFromFile(base+'vrml103.wrl');
  end;

  // copy generated VRML text into memo
  if Node.ImageIndex in idset then begin
    Memo1.Lines.Text:= VRMLFile.Text;
  end;

  Button1.Enabled:= (Node.ImageIndex>100)or (Node.ImageIndex in idset);
end;

procedure TForm2.Button1Click(Sender: TObject);
var FileName: string;
begin
  // Save generated VRML File
  FileName:=Format(base+ '\vrml%d.wrl',[TreeView1.Selected.ImageIndex]);
  Memo1.Lines.SaveToFile(FileName);
  // And run VRML browser
  exec( FileName, '', SW_SHOW, true);
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  base:= ExtractFilePath(Application.ExeName);
  VRMLFile:= TAiSVRMLFile.Create;
end;

end.
